<template>
  <div>
    <PageCard
      class="pageCard-padding background-header"
      :bordering="false"
      fontWeight="bold"
      titleSize=".925rem"
      :title="$t('deposit.payByCrypto.title')">
    </PageCard>
    <PageCard
      :bordering="false"
      class="pb-40">
      <div class="searching">
        <div class="searching-text searching-title">{{$t('deposit.payByCrypto.buyAnyCrypto')}}</div>
        <div class="searching-text searching-subtitle">{{$t('deposit.payByCrypto.muchCheaper')}}</div>
        <div class="searching-block">
          <BInput
            class="mt-15"
            :label="$t('deposit.search')"
            v-model="search"></BInput>
        </div>
      </div>
      <swiper
        style="overflow: initial;"
        ref="mySwiper"
        :options="swiperOptions">
        <swiper-slide
          v-for="(item, key) in currencyList"
          :key="key">
          <div class="swiper_container">
            <div
              class="swiper_container-item"
              v-for="(curr, ckey) in item"
              @click="select(curr)"
              :key="ckey">
              <div
                class="swiper_tapper"
                :class="{active: active===curr.ticker}">
                <div class="swiper_tapper-img swiper-slide">
                  <img
                    class="swiper_tapper-img-item swiper-lazy"
                    :src="curr.image"
                    :alt="curr.ticker">
                </div>
                <div class="swiper_tapper-title">
                  <div class="swiper_tapper-title-ticker">{{curr.ticker}}</div>
                  <div class="swiper_tapper-title-name">{{curr.name}}</div>
                </div>
              </div>
            </div>
          </div>
        </swiper-slide>
        <div
          class="swiper-pagination"
          slot="pagination"></div>
      </swiper>
    </PageCard>
  </div>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import BInput from '~/components/UI/Input_search';
  import {Swiper, SwiperSlide} from 'vue-awesome-swiper'
  import 'swiper/css/swiper.css'

  const chunkArray = (myArray, chunk_size) => {
    let index = 0;
    let arrayLength = myArray.length;
    let tempArray = [];

    for (index = 0; index < arrayLength; index += chunk_size) {
      let myChunk = myArray.slice(index, index + chunk_size);
      tempArray.push(myChunk);
    }

    return tempArray;
  };

  export default {
    name: "Step1",
    data() {
      return {
        swiperOptions: {
          slidesPerView: 'auto',
          loop: false,
          centeredSlides: true,
          initialSlide: 0,
          pagination: {
            el: '.swiper-pagination',
            type: 'bullets',
          },
        },
        active: '',
        search: ''
      }
    },
    components: {
      PageCard,
      Swiper,
      SwiperSlide,
      BInput
    },
    events: {
      'deposit:opened': function (event, param) {
        const swiper = this.$refs['mySwiper'];
        swiper.updateSwiper();
        swiper.$swiper.slideTo(0);
        const btc = this.depositList.filter(item => item.ticker === 'btc');
        if (btc && btc.length) {
          this.$nextTick(_ => {
            this.select(btc[0]);
          });
        }
      }
    },
    computed: {
      swiper() {
        return this.$refs.mySwiper.$swiper
      },
      depositList() {
        return this.$store.state.deposit.data;
      },
      currencyList() {
        const search = this.search.toLowerCase();
        const filteredData = this.depositList.map(item => {
          if (item.ticker.toLowerCase().indexOf(search.toLowerCase()) > -1 || (item.name.toLowerCase().indexOf(search.toLowerCase()) > -1)) {
            const it = Object.assign({}, item);
            it.name = it.name.split(' ')[0];
            return it
          }
        }).filter(i => i);
        return chunkArray(filteredData, 9);
      }
    },
    methods: {
      select(curr) {
        this.active = curr.ticker;
        this.$emit('select', curr);
      }
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .swiper-slide {
    width: 80%;
  }

  .swiper-pagination {
    bottom: -25px;
    @media screen and (max-width: 768px) {
      bottom: -35px;
    }
  }

  .searching {
    padding: 20px 40px;
    background-color: #151e2f;
    &-text {
      text-transform: uppercase;
      font-weight: bold;
    }
    &-subtitle {
      color: #36d253;
    }
  }
</style>
